﻿using System;
using System.Threading;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buddy.Common.Plugins;
using Buddy.Swtor;
using Buddy.Swtor.Objects;
using Buddy.CommonBot;
using System.Windows;
using System.Diagnostics;

namespace ViewAbilities
{
    class ViewAbilities : IPlugin
    {
        
        #region Implementation of IEquatable<IPlugin>

        /// <summary>

        /// Indicates whether the current object is equal to another object of the same type.

        /// </summary>

        /// <returns>

        /// true if the current object is equal to the <paramref name="other"/> parameter; otherwise, false.

        /// </returns>

        /// <param name="other">An object to compare with this object.</param>

        public bool Equals(IPlugin other)
        {

            return other.Name == Name;

        }

        #endregion

        #region Implementation of IPlugin

        //Set the Number of the QuickSlot here
        public int QuickSlot = 1;


        public Dictionary<TorCharacter, DateTime> PlayersHit = new Dictionary<TorCharacter, DateTime>();
        public TorCharacter CurrentTarget;
        public DateTime LastSnowBallThrown;


        public string Author { get { return "w118cmh"; } }

        public Version Version { get { return new Version(0, 1); } }

        public string Name { get { return "Life Day Snowball Fight"; } }

        public string Description { get { return "Will use snowball and throw at players who do not have the debuff created by you."; } }

        public Window DisplayWindow { get { return null; } }

        
      
        /// <summary> Executes the pulse action. This is called every "tick" of the bot. </summary>

        public void OnPulse()
        {

            if (DateTime.Now.Subtract(LastSnowBallThrown).TotalSeconds > 16)
            {
                GuiApiManager.AcceptPendingQuestRewards(0xE000A4B765423256, 0);

                //CurrentTarget = ObjectManager.GetObjects<TorPlayer>().First(o => o.Distance < 2.8f && o.Distance > .4f && o != BuddyTor.Me && !o.Debuffs.Any(p => p.CasterGuid == BuddyTor.Me.Guid) && !o.Buffs.Any(p => p.CasterGuid == BuddyTor.Me.Guid) && o.InLineOfSight);

                List<TorPlayer> Players = ObjectManager.GetObjects<TorPlayer>().Where(o => o.Distance < 2.8f && o.Distance > .4f && o != BuddyTor.Me && o.InLineOfSight).ToList();

                foreach (TorPlayer player in Players)
                {
                    try
                    {
                        if (player.Buffs.Any(o => o.Name == "Snowflakes" && o.Caster == BuddyTor.Me))
                        {

                        }

                        else
                        {
                            CurrentTarget = player;
                        }
                    }

                    catch (Exception ex)
                    {
                        //blah!
                    }
                }

                using (BuddyTor.Memory.AcquireFrame())
                {
                    BuddyTor.Me.SetTarget(CurrentTarget);
                    BuddyTor.Me.UseQuickslotAction(QuickSlot);
                }

                LastSnowBallThrown = DateTime.Now;      
            }
           
        }

        

        /// <summary> Executes the initialize action. This is called at initial bot startup. (When the bot itself is started, not when Start() is called) </summary>
        public void OnInitialize()
        {            
           
        }


        public void OnStart()
        {
            LastSnowBallThrown = DateTime.Now;
            
        }

        public void OnStop()
        {
            
        }

        /// <summary> Executes the shutdown action. This is called when the bot is shutting down. (Not when Stop() is called) </summary>

        public void OnShutdown()
        {

        }

        /// <summary> Executes the enabled action. This is called when the user has enabled this specific plugin via the GUI. </summary>

        public void OnEnabled()
        {
             
        }


        /// <summary> Executes the disabled action. This is called whent he user has disabled this specific plugin via the GUI. </summary>

        public void OnDisabled()
        {
            
        }     

        #endregion


    }
}
